local TSM = select(2, ...)
local TSM = LibStub("AceAddon-3.0"):NewAddon(TSM,"TradeSkillMaster_PriceReply", "AceConsole-3.0")
local TSMEvents = TSM:NewModule("TSMEvents", "AceEvent-3.0")
local AceGUI = LibStub("AceGUI-3.0")
TSM.version = GetAddOnMetadata("TradeSkillMaster_PriceReply", "Version")

------------------ VARIABLES -----------
local ReplyChannelSayDropDownBox = {["WHISPER"]="WHISPER",["SAY"]="SAY"}
local ReplyChannelGuildDropDownBox = {["WHISPER"]="WHISPER",["GUILD"]="GUILD"}
local AddonEnabled--- to stop abuse
local Trigger --- The Trigger holder
local AddonDelayCheck = 0
local LastRunDelayTime = 0
local LockOutTime -- trigger to stop abuse default 15
local Channel --- triggers for whispers or guild or say
local GuildChannel
local TriggerLength --- gets length of triggers
local CheckEnabled --- hold whether the checkbox is checked or not

function TSMEvents:AddonEnabled()


end
-- Initiate TSM Stuff so it recognizes it
function TSM:OnEnable()
	-- Register with TSMAPI
	TSM.icons = { { side = "module", desc = "Price Reply", slashCommand = "pr", callback = TSM.Load , icon = "Interface\\Icons\\ACHIEVEMENT_GUILDPERK_QUICK AND DEAD" } }
	TSMAPI:NewModule(TSM)	
	
	--- Default all saved variables to a default value on first run time.
	if not TradeSkillMaster_PriceReplyDB then
		TradeSkillMaster_PriceReplyDB = {}
	end
	if TradeSkillMaster_PriceReplyDB.AddonEnabled == nil or TradeSkillMaster_PriceReplyDB.AddonEnabled == "Enabled" then -- last check to fix some old issues
		TradeSkillMaster_PriceReplyDB.AddonEnabled = true
	end
	if not TradeSkillMaster_PriceReplyDB.Trigger then
		TradeSkillMaster_PriceReplyDB.Trigger = "PR: "
	end
	if not TradeSkillMaster_PriceReplyDB.LockOutTime then
		TradeSkillMaster_PriceReplyDB.LockOutTime = 15
	end
	if not TradeSkillMaster_PriceReplyDB.Channel then
		TradeSkillMaster_PriceReplyDB.Channel = "WHISPER"
	end
	if not TradeSkillMaster_PriceReplyDB.GuildChannel then
		TradeSkillMaster_PriceReplyDB.GuildChannel = "WHISPER"
	end

	Channel = TradeSkillMaster_PriceReplyDB.Channel
	GuildChannel = TradeSkillMaster_PriceReplyDB.GuildChannel
	LockOutTime = TradeSkillMaster_PriceReplyDB.LockOutTime
	Trigger = TradeSkillMaster_PriceReplyDB.Trigger
	TriggerLength = string.len(Trigger)
	AddonEnabled = TradeSkillMaster_PriceReplyDB.AddonEnabled
	
	-- Register events with Ace3
	TSMEvents:RegisterEvent("CHAT_MSG_GUILD")
	TSMEvents:RegisterEvent("CHAT_MSG_WHISPER")
	TSMEvents:RegisterEvent("CHAT_MSG_SAY")
end


--------------- TSM BUILD PAGE-------------
function TSM.Load(parent)
	local page = {
		{
		 type = "SimpleGroup",
		 layout = "list",
		 children = {
			{
				type = "InlineGroup",
				fullWidth = true,
				layout = "flow",
				title = "Price reply Options",
				children = {
					{
					type = "EditBox",
					value = TradeSkillMaster_PriceReplyDB.Trigger,
					label = "Trigger",
					fullWidth = false,
					disabled = false,
					tooltip = "The trigger used at the start of a sentence for asking the price",
					callback = function(_,_,value) Trigger = tostring(value);TradeSkillMaster_PriceReplyDB.Trigger = Trigger; end,
					},
					{
					type = "CheckBox",
					value = TradeSkillMaster_PriceReplyDB.AddonEnabled,
					label = "Enable/Disable Addon",
					fullWidth = false,
					disabled = false,
					tooltip = "Enable/Disable the addon",
					callback = function(_,_,value) 
						if value == true then
							TradeSkillMaster_PriceReplyDB.AddonEnabled = true
						else
							TradeSkillMaster_PriceReplyDB.AddonEnabled = false
						end
					end,
					},
					{
					type = "EditBox",
					value = TradeSkillMaster_PriceReplyDB.LockOutTime,
					label = "Lockout Time",
					fullwidth = false,
					disabled = false,
					tooltip = "Lockout time in seconds before another command can be processed",
					callback = function(_,_,value)
						local value = tonumber(value)
						if type(value)=='number' then
							LockOutTime = value;
							TradeSkillMaster_PriceReplyDB.LockOutTime = LockOutTime;
						end
					end,
					},
					{
					type = "Button",
					text = "Reset all Price Reply settings",
					fullwidth = true,
					disabled = false,
					tooltip = "Reset all of price reply settings to default values",
					callback = function()
						TradeSkillMaster_PriceReplyDB.AddonEnabled = true;
						TradeSkillMaster_PriceReplyDB.Trigger = "PR: ";
						TradeSkillMaster_PriceReplyDB.LockOutTime = 15
						TradeSkillMaster_PriceReplyDB.Channel = "WHISPER"
						end,
					},
				},
			},
			{
				type = "InlineGroup",
				layout = "flow",
				fullWidth = true,
				title = "Reply Options for channels",
				children = {
					{
					type = "Dropdown",
					multiselect = false,
					list = ReplyChannelSayDropDownBox,
					value = TradeSkillMaster_PriceReplyDB.Channel,
					label = "Select channel to reply to for say:",
					fullWidth = false,
					disabled = false,
					tooltip = "Select a reply method",
					callback = function(_,_,key) Channel = tostring(key); TradeSkillMaster_PriceReplyDB.Channel = Channel; end,
					},
					{
					type = "Dropdown",
					multiselect = false,
					list = ReplyChannelGuildDropDownBox,
					value = TradeSkillMaster_PriceReplyDB.GuildChannel,
					label = "Select channel to reply to for guild:",
					fullWidth = false,
					disabled = false,
					tooltip = "Select a reply method",
					callback = function(_,_,key) GuildChannel = tostring(key); TradeSkillMaster_PriceReplyDB.GuildChannel = GuildChannel; end,
					},
				},
			},
		},
	}
}
	TSMAPI:BuildPage(parent, page)
end

--- End TSM Stuff


----------Whisper Event----------------
function TSMEvents:CHAT_MSG_WHISPER(_,MSG,Auth)
	--print(MSG)
	AddonEnabled = TradeSkillMaster_PriceReplyDB.AddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,TriggerLength)
	local MSG = MSG
	local Auth = Auth
	--- Price Get --
	local PriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	--[[ Seen Get -- SOON(tm)
	local ItemString = TSMAPI:GetItemString(MSG)
	print(ItemString)
	local Seen = TSMAPI:ModuleAPI("AuctionDB","seenCount")
	print(Seen)]]
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:ModuleAPI("AuctionDB", "lastCompleteScanTime")
	local TimeLastScannedHours = floor(TSM:ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local TimeLastScannedMinutes = floor(TSM:ConvertTime(Current, Past) / 60) -- convert minutes
	local LastRunCheck = TSM:LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,Trigger) and PriceMarket ~= nil and PriceMin ~= nil and AddonEnabled == true and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = TSM:ConvertPriceToMoney(PriceMarket,"Gold")
		local MktSILVER = TSM:ConvertPriceToMoney(PriceMarket,"Silver")
		local MktCOPPER = TSM:ConvertPriceToMoney(PriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = TSM:ConvertPriceToMoney(PriceMin,"Gold")
		local MinSILVER = TSM:ConvertPriceToMoney(PriceMin,"Silver")
		local MinCOPPER = TSM:ConvertPriceToMoney(PriceMin,"Copper")

		--- Message to send and channel--
		local THEMESSAGE = ("PR: MP: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."MB: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Scanned: "..TimeLastScannedHours.." Hrs "..TimeLastScannedMinutes.." Mins Ago")
		print(THEMESSAGE)
		SendChatMessage(THEMESSAGE, "WHISPER", "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	else
		--print(MSG,Trigger,PriceMarket,PriceMin,AddonEnabled,LastRunCheck)
	end
end


----- Guild event ----
function TSMEvents:CHAT_MSG_GUILD(_,MSG,Auth)
	--print(MSG)
	AddonEnabled = TradeSkillMaster_PriceReplyDB.AddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,TriggerLength)
	local MSG = MSG
	local Auth = Auth
	local GuildChannel = TradeSkillMaster_PriceReplyDB.GuildChannel --- Only used for guild channel
	--- Price Get --
	local PriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:ModuleAPI("AuctionDB", "lastCompleteScanTime")
	local TimeLastScannedHours = floor(TSM:ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local TimeLastScannedMinutes = floor(TSM:ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = TSM:LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,Trigger) and PriceMarket ~= nil and PriceMin ~= nil and AddonEnabled == true and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = TSM:ConvertPriceToMoney(PriceMarket,"Gold")
		local MktSILVER = TSM:ConvertPriceToMoney(PriceMarket,"Silver")
		local MktCOPPER = TSM:ConvertPriceToMoney(PriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = TSM:ConvertPriceToMoney(PriceMin,"Gold")
		local MinSILVER = TSM:ConvertPriceToMoney(PriceMin,"Silver")
		local MinCOPPER = TSM:ConvertPriceToMoney(PriceMin,"Copper")

		--- Message to send and channel--
		local THEMESSAGE = ("PR: MP: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."MB: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Scanned: "..TimeLastScannedHours.." Hrs "..TimeLastScannedMinutes.." Mins Ago")
		--print(PRTHEMESSAGE)
		SendChatMessage(THEMESSAGE, GuildChannel, "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	else
		--print(MSG,Trigger,PriceMarket,PriceMin,AddonEnabled,LastRunCheck)
	end
end


---- /say ---
function TSMEvents:CHAT_MSG_SAY(_,MSG,Auth)
	--print(MSG)
	AddonEnabled = TradeSkillMaster_PriceReplyDB.AddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,TriggerLength)
	local MSG = MSG
	local Auth = Auth
	--- Price Get --
	local PriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:ModuleAPI("AuctionDB", "lastCompleteScanTime")
	local TimeLastScannedHours = floor(TSM:ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local TimeLastScannedMinutes = floor(TSM:ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = TSM:LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,Trigger) and PriceMarket ~= nil and PriceMin ~= nil and AddonEnabled == true and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = TSM:ConvertPriceToMoney(PriceMarket,"Gold")
		local MktSILVER = TSM:ConvertPriceToMoney(PriceMarket,"Silver")
		local MktCOPPER = TSM:ConvertPriceToMoney(PriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = TSM:ConvertPriceToMoney(PriceMin,"Gold")
		local MinSILVER = TSM:ConvertPriceToMoney(PriceMin,"Silver")
		local MinCOPPER = TSM:ConvertPriceToMoney(PriceMin,"Copper")

		--- Message to send and channel--
		local THEMESSAGE = ("PR: MP: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."MB: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Scanned: "..TimeLastScannedHours.." Hrs "..TimeLastScannedMinutes.." Mins Ago")
		--print(PRTHEMESSAGE)
		SendChatMessage(THEMESSAGE, Channel, "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	else
		--print(MSG,Trigger,PriceMarket,PriceMin,AddonEnabled,LastRunCheck)
	end
end

-------------------------- Useful Functions --------------
function TSM:ConvertPriceToMoney(PRICE,TYPE)
	local GOLD
	local SILVER
	local COPPER
	if PRICE == nil then Price = 0 end -- make sure it is a number
	if TYPE == "Gold" then
		GOLD = floor(PRICE/10000) -- divide price by 10000 to decide gold and floor it to get rid of hang overs
		return GOLD or 0 -- Make sure it always returns a number
	elseif TYPE == "Silver" then
		SILVER = floor(strsub(PRICE, -4) / 100) -- strsub will only see the last 4 numbers of a sentece and divide it by 100
		return SILVER or 0
	elseif TYPE == "Copper" then
		COPPER = floor(strsub(PRICE, -2)) -- no division needed for 10th's
		return COPPER or 0
	end
end
------
function TSM:ConvertTime(Current, Past)
	local Current = Current
	local Past = Past
	local Difference = (Current - Past)
	return Difference
end
----------
function TSM:LastRunCheck()
	local Current = time()
	local Past = (LastRunDelayTime + LockOutTime)
	if Current > Past then
		return "Yes"
	else
		return "No"
	end
end
-----------
